/*  lil-gp Genetic Programming System, version 1.0, 11 July 1995
 *  Copyright (C) 1995  Michigan State University
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of version 2 of the GNU General Public License as
 *  published by the Free Software Foundation.
 * 
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 * 
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *  
 *  Douglas Zongker       (zongker@isl.cps.msu.edu)
 *  Dr. Bill Punch        (punch@isl.cps.msu.edu)
 *
 *  Computer Science Department
 *  A-714 Wells Hall
 *  Michigan State University
 *  East Lansing, Michigan  48824
 *  USA
 *  
 */

#ifndef _APP_H
#define _APP_H

#include <lilgp.h>
#include "defines.h"




typedef struct
{
	/* Included to patch the current_individual bug...leave this alone */
	individual* current_individual;
	/* End patch */
     int day;
     int stockNum;
} globaldata;


#define COMPARE_TO_SEQ 0
#define USE_GPU 1
#define USE_SEQ 0

//extern globaldata g;


void app_eval_fitness2 ( individual *, int);
//extern void doTest();
void app_eval_pop(population * pop);
void app_eval_pop_gpu(population *pop);
void init_copy_data_gpu();

void evalBestTest(individual * ind);
void evalBestTrain(individual * ind);

float evalSignalsOutput(int **, float[], int[], int, int, char*);
void evalSignals(int **, float[], int[], int, int);
void generateSignals(char*, int, int, int, int**, int, int, int);

void calculateIndicators(int, int, int, int);
void initMACD(int, int, int, int);
void initEOM(int, int, int, int);
void initMFI(int, int, int, int);
void initCCI(int, int, int, int);
float calcCCI(int, int, int);
void initMAs(int, int, int, int);
void initPVINVI(int, int, int, int);
void initStocks(int);
float typicalPrice(StockDay);
void printDay(StockDay);
float MA(int, int, int);
float EMA(int, float, int, int);

void pretty_print_individual_rpn ( individual *ind );
void my_pretty_print_individual ( individual *ind);
void my_pretty_print_tree ( lnode *data, FILE *fil );
void my_pretty_print_tree_recurse ( lnode **l, FILE *fil );

void pretty_print_tree_rpn ( lnode *data, FILE *fil );
void pretty_print_tree_rpn_recurse( lnode **l, FILE*fil);
char* parseOp(char* op);

#endif
