/*
 * defines.h
 *
 *  Created on: Oct 19, 2010
 *      Author: wolf
 */

#ifndef DEFINES_H_
#define DEFINES_H_

//Struct to store information about a specific day/stock
typedef struct{
	char date[10];
	float high;
	float low;
	float open;
	float close;
	double volume;
}StockDay;

//Definitions for long and short days
//long days
#define START_TEST_DAY 968
#define END_TEST_DAY 1167
#define START_DAY 200
#define END_DAY 967
#define SEED_DAYS 200

//short days
/*#define START_TEST_DAY 456
#define END_TEST_DAY 505
#define START_DAY 200
#define END_DAY 455
#define SEED_DAYS 200
*/


#define TRAINING_DAYS (END_DAY - START_DAY + 1)
#define TESTING_DAYS (END_TEST_DAY - START_TEST_DAY + 1)
#define COUNT (TRAINING_DAYS + SEED_DAYS + TESTING_DAYS)
#define MAX_DATE_LENGTH 10

//Number of stocks to test on
#define NUM_STOCKS 32
//Initial money of stocks
#define INIT_MONEY 10000.0f
//Population size (must match the one in the input file)
#define POP_SIZE 25000
//Number of trees being used
#define NUM_TREES 2
//Commission Fee
#define COMMISION_FEE 1

//Enumerations for indicators
enum{
	vMA1,
	vMA5,
	vMA10,
	vMA15,
	vMA25,
	vMA50,
	vMA75,
	vMA100,
	vMA150,
	vMA200,
	vEMA5,
	vEMA9,
	vEMA15,
	vEMA20,
	vEMA25,
	vCP,
	vTP
};

enum{
	vNVIG,
	vNVIL,
	vPVIG,
	vPVIL,
	vMACDG,
	vMACDL,
	vMACDGZ,
	vMACDLZ,
	vCCIG,
	vCCIL,
	vEOMG,
	vEOML,
	vMFIG,
	vMFIL
};

//Number of floating point and boolean indicators
#define NUM_FLOAT_INDS 17
#define NUM_BOOL_INDS 14

//Operation codes for individuals
#define DOUBLE 1
#define BOOLEAN 0
#define IGNORE -1
#define AND "&"
#define OR "|"
#define NOT "!"
#define GT ">"
#define LT "<"
#define MA1 "a"
#define MA5 "b"
#define MA10 "c"
#define MA15 "d"
#define MA25 "e"
#define MA50 "f"
#define MA75 "g"
#define MA100 "h"
#define MA150 "i"
#define MA200 "j"
#define MA365 "k"
#define EA5 "l"
#define EA9 "m"
#define EA15 "n"
#define EA20 "o"
#define EA25 "p"
#define NVIG "q"
#define NVIL "r"
#define PVIG "s"
#define PVIL "t"
#define CLOSING "u"
#define TYPICAL "v"
#define MACDL "w"
#define MACDG "x"
#define CCIG "y"
#define CCIL "z"
#define EOMG "A"
#define EOML "B"
#define MFIG "E"
#define MFIL "F"
#define MACDGZ "K"
#define MACDLZ "L"
#endif /* DEFINES_H_ */


