/*  lil-gp Genetic Programming System, version 1.0, 11 July 1995
 *  Copyright (C) 1995  Michigan State University
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of version 2 of the GNU General Public License as
 *  published by the Free Software Foundation.
 * 
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 * 
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *  
 *  Douglas Zongker       (zongker@isl.cps.msu.edu)
 *  Dr. Bill Punch        (punch@isl.cps.msu.edu)
 *
 *  Computer Science Department
 *  A-714 Wells Hall
 *  Michigan State University
 *  East Lansing, Michigan  48824
 *  USA
 *  
 */

#include <math.h>
#include <stdio.h>
#include <function.h>


#include <lilgp.h>

extern float fIndVals[NUM_STOCKS][NUM_FLOAT_INDS][COUNT];
extern char bIndVals[NUM_STOCKS][NUM_BOOL_INDS][COUNT];

DATATYPE f_AND (int tree, farg *args){/*printf("1\n");fflush(stdout);*/globaldata* g = get_globaldata(); return args[0].d && args[1].d;}
DATATYPE f_OR (int tree, farg *args){/*printf("2\n");fflush(stdout);*/globaldata* g = get_globaldata(); return args[0].d || args[1].d;}
DATATYPE f_NOT (int tree, farg *args){/*printf("3\n");fflush(stdout);*/globaldata* g = get_globaldata(); return !args[0].d;}
DATATYPE f_GT (int tree, farg *args){/*printf("4\n");fflush(stdout);*/globaldata* g = get_globaldata(); return args[0].d > args[1].d;}
DATATYPE f_LT (int tree, farg *args){/*printf("5\n");fflush(stdout);*/globaldata* g = get_globaldata(); return args[0].d < args[1].d;}
DATATYPE f_MA1 (int tree, farg *args){/*printf("6\n");fflush(stdout);*/globaldata* g = get_globaldata(); return fIndVals[g->stockNum][vMA1][g->day];}
DATATYPE f_MA5 (int tree, farg *args){/*printf("7\n");fflush(stdout);*/globaldata* g = get_globaldata(); return fIndVals[g->stockNum][vMA5][g->day];}
DATATYPE f_MA10 (int tree, farg *args){/*printf("8\n");fflush(stdout);*/globaldata* g = get_globaldata(); return fIndVals[g->stockNum][vMA10][g->day];}
DATATYPE f_MA15 (int tree, farg *args){/*printf("9\n");fflush(stdout);*/globaldata* g = get_globaldata(); return fIndVals[g->stockNum][vMA15][g->day];}
DATATYPE f_MA25 (int tree, farg *args){/*printf("10\n");fflush(stdout);*/globaldata* g = get_globaldata(); return fIndVals[g->stockNum][vMA25][g->day];}
DATATYPE f_MA50 (int tree, farg *args){/*printf("11\n");fflush(stdout);*/globaldata* g = get_globaldata(); return fIndVals[g->stockNum][vMA50][g->day];}
DATATYPE f_MA75 (int tree, farg *args){/*printf("12\n");fflush(stdout);*/globaldata* g = get_globaldata(); return fIndVals[g->stockNum][vMA75][g->day];}
DATATYPE f_MA100 (int tree, farg *args){/*printf("13\n");fflush(stdout);*/globaldata* g = get_globaldata(); return fIndVals[g->stockNum][vMA100][g->day];}
DATATYPE f_MA150 (int tree, farg *args){/*printf("14\n");fflush(stdout);*/globaldata* g = get_globaldata(); return fIndVals[g->stockNum][vMA150][g->day];}
DATATYPE f_MA200 (int tree, farg *args){/*printf("15\n");fflush(stdout);*/globaldata* g = get_globaldata(); return fIndVals[g->stockNum][vMA200][g->day];}
DATATYPE f_EA25 (int tree, farg *args){/*printf("16\n");fflush(stdout);*/globaldata* g = get_globaldata(); return fIndVals[g->stockNum][vEMA25][g->day];}
DATATYPE f_EA5 (int tree, farg *args){/*printf("17\n");fflush(stdout);*/globaldata* g = get_globaldata(); return fIndVals[g->stockNum][vEMA5][g->day];}
DATATYPE f_EA9 (int tree, farg *args){/*printf("18\n");fflush(stdout);*/globaldata* g = get_globaldata(); return fIndVals[g->stockNum][vEMA9][g->day];}
DATATYPE f_EA15 (int tree, farg *args){/*printf("19\n");fflush(stdout);*/globaldata* g = get_globaldata(); return fIndVals[g->stockNum][vEMA15][g->day];}
DATATYPE f_EA20 (int tree, farg *args){/*printf("20\n");fflush(stdout);*/globaldata* g = get_globaldata(); return fIndVals[g->stockNum][vEMA20][g->day];}
DATATYPE f_NVIG (int tree, farg *args){/*printf("21\n");fflush(stdout);*/globaldata* g = get_globaldata(); return bIndVals[g->stockNum][vNVIG][g->day];}
DATATYPE f_NVIL (int tree, farg *args){/*printf("22\n");fflush(stdout);*/globaldata* g = get_globaldata(); return bIndVals[g->stockNum][vNVIL][g->day];}
DATATYPE f_PVIG (int tree, farg *args){/*printf("23\n");fflush(stdout);*/globaldata* g = get_globaldata(); return bIndVals[g->stockNum][vPVIG][g->day];}
DATATYPE f_PVIL (int tree, farg *args){/*printf("24\n");fflush(stdout);*/globaldata* g = get_globaldata(); return bIndVals[g->stockNum][vPVIL][g->day];}
DATATYPE f_CLOSING (int tree, farg *args){/*printf("25\n");fflush(stdout);*/globaldata* g = get_globaldata(); return fIndVals[g->stockNum][vCP][g->day];}
DATATYPE f_TYPICAL (int tree, farg *args){/*printf("26\n");fflush(stdout);*/globaldata* g = get_globaldata(); return fIndVals[g->stockNum][vTP][g->day];}
DATATYPE f_MACDL (int tree, farg *args){/*printf("27\n");fflush(stdout);*/globaldata* g = get_globaldata(); return bIndVals[g->stockNum][vMACDL][g->day];}
DATATYPE f_MACDG (int tree, farg *args){/*printf("28\n");fflush(stdout);*/globaldata* g = get_globaldata(); return bIndVals[g->stockNum][vMACDG][g->day];}
DATATYPE f_CCIG (int tree, farg *args){/*printf("29\n");fflush(stdout);*/globaldata* g = get_globaldata(); return bIndVals[g->stockNum][vCCIG][g->day];}
DATATYPE f_CCIL (int tree, farg *args){/*printf("30\n");fflush(stdout);*/globaldata* g = get_globaldata(); return bIndVals[g->stockNum][vCCIL][g->day];}
DATATYPE f_EOMG (int tree, farg *args){/*printf("31\n");fflush(stdout);*/globaldata* g = get_globaldata(); return bIndVals[g->stockNum][vEOMG][g->day];}
DATATYPE f_EOML (int tree, farg *args){/*printf("32\n");fflush(stdout);*/globaldata* g = get_globaldata(); return bIndVals[g->stockNum][vEOML][g->day];}
DATATYPE f_MFIG (int tree, farg *args){/*printf("33\n");fflush(stdout);*/globaldata* g = get_globaldata(); return bIndVals[g->stockNum][vMFIG][g->day];}
DATATYPE f_MFIL (int tree, farg *args){/*printf("34\n");fflush(stdout);*/globaldata* g = get_globaldata(); return bIndVals[g->stockNum][vMFIL][g->day];}
DATATYPE f_MACDLZ (int tree, farg *args){/*printf("35\n");fflush(stdout);*/globaldata* g = get_globaldata(); return bIndVals[g->stockNum][vMACDLZ][g->day];}
DATATYPE f_MACDGZ (int tree, farg *args){/*printf("36\n");fflush(stdout);*/globaldata* g = get_globaldata(); return bIndVals[g->stockNum][vMACDGZ][g->day];}
